codex_app/codex/urls.py
from django.urls import path

from codex.views import (
    close_path,
    name_path,
    open_path,
    create_path,
    create_transitional_text,
    delete_par_annotation,
    get_distinct_terms,
    get_img_annotation_picto,
    get_user_path_list,
    path_add_node,
    path_delete_node,
    path_swap_nodes,
    post_annotation_quality,
    post_img_annotation,
    post_par_annotation,
    get_img_annotation_image,
)

urlpatterns = [
    path("terms/", get_distinct_terms),
    path(
        "image/annotation/image/<int:id>",
        get_img_annotation_image,
        name="get_img_annotation_image",
    ),
    path(
        "image/annotation/picto/<int:id>",
        get_img_annotation_picto,
        name="get_img_annotation_picto",
    ),
    path("paragraph/annotation/", post_par_annotation),
    path("paragraph/annotation/<int:id>", delete_par_annotation),
    path("image/annotation/", post_img_annotation),
    path("annotation/quality/", post_annotation_quality),
    # path
    path("path/user/", get_user_path_list),
    path("path/create/", create_path),
    path("path/close/<int:id>", close_path),
    path("path/open/<int:id>", open_path),
    path("path/name/<int:id>", name_path),
    path("path/delete/<int:pid>/<int:nid>", path_delete_node),
    path("path/swap/<int:pid>/<int:nid1>/<int:nid2>", path_swap_nodes),
    path("path/add/<node_type>/<int:pid>/<int:tid>", path_add_node),
    path("transitional/create/", create_transitional_text),
]

codex_app/codex_app/urls.py
"""codex_app URL Configuration
"""
from django.contrib import admin
from django.urls import path, include
from django.conf import settings

from .views import (
    get_category,
    get_image,
    get_image_index,
    get_index,
    get_relationships,
    get_relationships_image,
    get_root,
    get_term,
    get_term_index,
    get_text_index,
    get_text_list,
    get_text,
)


urlpatterns = [
    path("index.html", get_index, name="index"),
    path("index-text.html", get_text_index, name="get_text_index"),
    path("index-image.html", get_image_index, name="get_image_index"),
    path("index-term.html", get_term_index, name="get_term_index"),
    path(
        "relationships.html",
        get_relationships,
        name="get_relationships",
    ),
    path(
        "relationships.png",
        get_relationships_image,
        name="get_relationships_image",
    ),
    path(
        "texts.html",
        get_text_list,
        name="get_text_list",
    ),
    path(
        "text/<int:id>.html",
        get_text,
        name="get_text",
    ),
    path(
        "image/<int:id>.html",
        get_image,
        name="get_image",
    ),
    path(
        "term/<int:id>.html",
        get_term,
        name="get_term",
    ),
    path(
        "category/<int:id>.html",
        get_category,
        name="get_category",
    ),
    path("admin/", admin.site.urls),
    path("accounts/", include("django.contrib.auth.urls")),
    path("api/", include(("codex.urls", "codex"), namespace="codex")),
    path("viz0/", include("viz0.urls")),
    # path("viz1/", include("viz1.urls")),
    path("topo/", include("topo.urls")),
    # path("api/", include("codex.urls")),
    # path("__debug__/", include("debug_toolbar.urls")),
    path("", include("viz1.urls")),
]


if getattr(settings, "MEDIA_URL_DEV", None) is not None:
    from django.views.static import serve
    from django.urls import re_path

    MEDIA_ROOT = getattr(settings, "MEDIA_ROOT")
    MEDIA_URL = getattr(settings, "MEDIA_URL_DEV")
    if MEDIA_URL.endswith("/") is False:
        MEDIA_URL = MEDIA_URL + "/"
    if MEDIA_URL.startswith("/"):
        MEDIA_URL = MEDIA_URL[1:]
    urlpatterns += [
        re_path(
            f"^{MEDIA_URL}" + r"(?P<path>.*)$",
            serve,
            {
                "document_root": MEDIA_ROOT,
            },
        ),
    ]

codex_app/topo/urls.py
"""codex_app URL Configuration
"""
from django.urls import path

from .views import (
    get_index,
)


def prefix(p):
    return f"topo.{p}"


urlpatterns = [
    path(
        "index.html",
        get_index,
        name=prefix("index"),
    ),
]

codex_app/codex_app/views.py
from django.http import HttpResponse
from django.shortcuts import redirect, render, get_object_or_404
from django.middleware.csrf import get_token
from django.contrib.auth.decorators import login_required
from codex.models import (
    Image,
    ImageAnnotation,
    ParAnnotation,
    Relationship,
    Text,
    Term,
    TermCategory,
    TermCatCat,
    Qualifier,
)
from codex.serializers import (
    serialize_category,
    serialize_image,
    serialize_image_annotation,
    serialize_paragraph,
    serialize_paragraph_annotation,
    serialize_qualifier,
    serialize_term,
)
from json import dumps


def get_root(request):
    if request.user.is_anonymous:
        return render(request, "codex_app/root.html", {})
    return redirect("/index.html")


@login_required
def get_index(request):
    context = {}
    return render(request, "codex_app/index.html", context)


@login_required
def get_text_index(request):
    context = {
        "texts": list(Text.objects.prefetch_related("paragraph_set").all()),
    }
    return render(request, "codex_app/index-text.html", context)


@login_required
def get_image_index(request):
    context = {
        "images": list(Image.objects.all()),
    }
    return render(request, "codex_app/index-image.html", context)


@login_required
def get_term_index(request):
    context = {
        "terms": list(Term.objects.all().filter(is_relation=False).order_by("name")),
    }
    return render(request, "codex_app/index-term.html", context)


@login_required
def get_relationships(request):
    context = {
        "relationships": Relationship.objects.all(),
        "count": Relationship.objects.count(),
    }
    return render(request, "codex_app/rel-list.html", context)


def append_texts_for_term(term, texts):
    for a in term.annotation.select_related("paragraph__text").all():
        text = a.paragraph.text
        if text.id not in texts:
            texts[text.id] = {"text": text, "paragraphs": [], "count": 0}
        if a.paragraph.id not in [p["par"].id for p in texts[text.id]["paragraphs"]]:
            texts[text.id]["paragraphs"].append(
                {"par": a.paragraph, "annotations": [a]}
            )
            texts[text.id]["paragraphs"] = sorted(
                texts[text.id]["paragraphs"], key=lambda x: x["par"].order
            )
        else:
            for p in texts[text.id]["paragraphs"]:
                if p["par"].id == a.paragraph.id:
                    p["annotations"].append(a)

        texts[text.id]["count"] += 1


@login_required
def get_term(request, id):
    term = get_object_or_404(Term, pk=id)
    texts = {}
    append_texts_for_term(term, texts)

    images = {}

    for i in term.images.all():
        if i.image.id not in images:
            images[i.image.id] = {"image": i.image, "annotations": []}
        images[i.image.id]["annotations"].append(i)
    context = {
        "source": Relationship.objects.filter(source=term),
        "destination": Relationship.objects.filter(destination=term),
        "term": term,
        "texts": list(texts.values()),
        "images": list(images.values()),
    }
    return render(request, "codex_app/term.html", context)


@login_required
def get_category(request, id):
    category = get_object_or_404(TermCategory, pk=id)

    texts = {}
    for tcc in TermCatCat.objects.filter(category=category):
        for annot in ParAnnotation.objects.filter(term=tcc.term):
            append_texts_for_term(annot.term, texts)

    images = {}
    for annot in category.images.all():
        if annot.image.id not in images:
            images[annot.image.id] = {"image": annot.image, "annotations": []}
        images[annot.image.id]["annotations"].append(annot)

    context = {
        "category": category,
        "texts": list(texts.values()),
        "images": list(images.values()),
    }

    return render(request, "codex_app/category.html", context)


@login_required
def get_text_list(request):
    context = {
        "texts": Text.objects.all(),
        "count": Text.objects.count(),
    }
    return render(request, "codex_app/text-list.html", context)


# def get_text(request, id):
#     text = get_object_or_404(Text, pk=id)
#     paragraphs = []
#     for par in text.paragraph_set.order_by("order"):
#         blocks = []
#         last_end = 0
#         content = par.content
#         for note in par.annotation.all():
#             start = note.start
#             end = note.end
#             blocks.append({"term": None, "content": content[last_end:start]})
#             blocks.append({"term": note.term, "content": content[start:end]})
#             last_end = end

#         blocks.append({"term": None, "content": content[last_end:]})
#         paragraphs.append(
#             {
#                 "blocks": blocks,
#                 "id": par.id,
#             }
#         )

#     context = {
#         "text": text,
#         "paragraphs": paragraphs,
#         "terms": Term.objects.all(),
#     }
#     return render(request, "codex_app/text.html", context)


@login_required
def get_text(request, id):
    text = get_object_or_404(Text, pk=id)
    paragraphs = text.paragraph_set.order_by("order")
    terms = Term.objects.filter(is_relation=False)
    annotations = ParAnnotation.objects.filter(paragraph__text=text)
    qualifiers = Qualifier.objects.all()
    context = {
        "user": dumps(request.user.id),
        "csrf_token": get_token(request),
        "text": text,
        "paragraphs": dumps([serialize_paragraph(p) for p in paragraphs], indent=2),
        "terms": dumps([serialize_term(t) for t in terms], indent=2),
        "annotations": dumps(
            [serialize_paragraph_annotation(a) for a in annotations], indent=2
        ),
        "qualifiers": dumps([serialize_qualifier(q) for q in qualifiers]),
    }
    return render(request, "codex_app/text.html", context)


@login_required
def get_image(request, id):
    image = get_object_or_404(Image, pk=id)
    terms = Term.objects.filter(is_relation=False)
    categories = TermCategory.objects.all()
    annotations = ImageAnnotation.objects.filter(image=image)
    context = {
        "csrf_token": get_token(request),
        "title": image.name,
        "image": dumps(serialize_image(image)),
        "terms": dumps([serialize_term(t) for t in terms], indent=2),
        "categories": dumps([serialize_category(cat) for cat in categories], indent=2),
        "annotations": dumps(
            [serialize_image_annotation(a) for a in annotations], indent=2
        ),
    }
    return render(request, "codex_app/image.html", context)


@login_required
def get_relationships_image(request):
    import graphviz
    from tempfile import TemporaryDirectory

    dot = graphviz.Digraph(comment="Codex Relationships")
    for rel in Relationship.objects.all():
        dot.node(str(rel.source.id), rel.source.name)
        dot.node(str(rel.destination.id), rel.destination.name)
        dot.edge(str(rel.source.id), str(rel.destination.id), rel.kind.name)

    with TemporaryDirectory() as td:
        dot.render(filename="dot.gv", format="png", directory=td)
        f = open(f"{td}/dot.gv.png", "rb")
        data = f.read()
        f.close()
        return HttpResponse(
            content=data,
            headers={
                "Content-Type": "image/png",
            },
        )


# def append_annotations_for_term(term, annotations):
#     for a in term.annotation.select_related("paragraph__text").all():
#         text = a.paragraph.text
#         if text.id not in texts:
#             texts[text.id] = {"text": text, "paragraphs": [], "count": 0}
#         if a.paragraph.id not in [p["par"].id for p in texts[text.id]["paragraphs"]]:
#             texts[text.id]["paragraphs"].append(
#                 {"par": a.paragraph, "annotations": [a]}
#             )
#             texts[text.id]["paragraphs"] = sorted(
#                 texts[text.id]["paragraphs"], key=lambda x: x["par"].order
#             )
#         else:
#             for p in texts[text.id]["paragraphs"]:
#                 if p["par"].id == a.paragraph.id:
#                     p["annotations"].append(a)

#         texts[text.id]["count"] += 1

codex_app/codex_app/templates/codex_app/base.html
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8" />
        <meta http-equiv="X-UA-Compatible" content="IE=edge" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <title>
            {% block title %}Topological Atlas Codex{% endblock title %}
        </title>
        <style>
            {% block base_style %}
            #header {
                position: absolute;
                top: 0;
                width: 100%;
                height: 24px;
                padding-bottom: 6px;
                border-bottom: 1px solid grey;
                padding-top: 14px;
                background-color: #6a005d;
                color: white;
            }
            #topo-name {
                font-weight: bold;
                margin-left: 1em;
            }
            #topo-name a {
                color: white;
                text-decoration: none;
            }
            #content {
                position: absolute;
                top: 48px;
                bottom: 48px;
                left: 1em;
                right: 0;
                padding-right: 1em;
                overflow: auto;
            }
            #footer {
                position: absolute;
                bottom: 0;
                width:100%;
                height: 24px;
                padding-top: 14px;
                border-top: 1px solid grey;
                background-color: #6a005d;
                color: white;
            }

            body {
                font-family: sans-serif;
                width:100%;
                margin: 0;
                height:100%;
                overflow: hidden;
            }
            {% endblock base_style %}

            {% block style %}{% endblock style %}
        </style>
    </head>

    <body>
        <div id="header">
            {% block header %}
            <span id="topo-name"
                ><a href="{% url 'index' %}">Topological Atlas Codex</a></span
            >
            {% endblock header %}
        </div>
        <div id="content">{% block content %}{% endblock content %}</div>
        <div id="footer">
            {% block footer %}
            <span class=""></span>
            {% endblock footer %}
        </div>
    </body>
    <script type="module">
        {% block script %}{% endblock script %}
    </script>
</html>

codex_app/codex_app/templates/codex_app/category.html
{% extends "codex_app/base.html" %}
{% block title %}{{category.name}} — category{% endblock title %}
{% block style %}
#wrapper {
    max-width: 44em;
    margin-left: 3em;
}
.image-annotation-list {
display: flex;
flex-wrap: wrap;
}
.image-annotation-list .image-item {
width: 256px;
margin: 1em;
flex-shrink: 0;
}
.image-list .image-item img {
width: 100%;
}

.text-item{
margin: 6em 0;
}

.par-order {
float: left;
width: 2em;
font-size: 80%;
font-style: italic;
margin-left: -2em;
color: #5e5e5e;
}

.block {
/* color:rgb(83, 83, 83); */
color:rgb(126, 126, 126);
}
.block.code {
color:black;
/* font-weight: bold; */
}
.text-content:hover .block.code {
/* font-weight: bold; */
color:rgb(0, 24, 61);
}
.text-content:hover .block {
/* font-weight: bold; */
color:rgb(190, 190, 190);
}
{% endblock %}

{% block content %}
<div id="wrapper">
<h1>{{category.name}}</h1>
<div class="description">{{category.description}}</div>

<div class="image-list">
    {% for a in images%}
    <h3><a href="{% url 'get_image' a.image.id %}">{{a.image.name}}</a></h3>
    <div class="image-annotation-list">
        {% for ia in a.annotations %}
        <div class="image-item">
            <img class="annotation" src="{% url 'codex:get_img_annotation_image' ia.id %}" />
        </div>
        {% endfor %}
    </div>
    {% endfor %}
</div>


{% for item in texts%}
<div class="text-item">
    <h3>
        <a href="{% url 'get_text' item.text.id %}">{{item.text.title}}</a>
    </h3> 
    number of codes: {{item.count}}
    {% for p in item.paragraphs %}

    <p>
    <div class="par-order">{{p.par.order}}</div>
    <div class="text-content"
        data-intervals="[{% for a in p.annotations %}[{{a.start}},{{a.end}}]{%if not forloop.last %},{%endif%}{% endfor %}]">{{p.par.clean_content}}</div>
    </p>
    {% endfor %}
</div>
{% endfor %}

</div>
{% endblock %}


{% block script %}


function emptyElement(elem) {
    while (elem.firstChild) {
        removeElement(elem.firstChild);
    }
    return elem;
}

function removeElement(elem, keepChildren = false) {
    if (!keepChildren) {
        emptyElement(elem);
    }
    const parent = elem.parentNode;
    if (parent) {
        parent.removeChild(elem);
    }
}


const sortInterval = (a,b) => a[0] - b[0]

const sortIntervals = (is) => is.sort(sortInterval)

const compileAnnotations = (content, rawIntervals) => {
    const start = 0;
    const end = content.length;
    const intervals = [
    ...new Set(
        sortIntervals(rawIntervals).reduce(
            (acc, i) => acc.concat(i[0], i[1]),
            [start, end]
            )
        ),
    ].sort((a, b) => a - b);

    const inInterval = (left, right) => rawIntervals.filter(
        (a) => a[0] < right && a[1] > left
    ).length > 0;

    const blocks= [];
    for (let i = 1; i < intervals.length; i += 1) {
        blocks.push({
            start: intervals[i - 1],
            end: intervals[i],
            content: content.slice(intervals[i - 1], intervals[i]),
            isCode: inInterval(intervals[i - 1], intervals[i])
        });
    }
    return blocks;

}

const highlightCode = (elem) => {
    const intervals = JSON.parse(elem.getAttribute('data-intervals'))
    const content = elem.textContent
    const blocks = compileAnnotations(content, intervals)
    emptyElement(elem)
    blocks.forEach(block => {
        const className = `block ${block.isCode ? 'code' : ''}`
        const span = document.createElement('span')
        const text = document.createTextNode(block.content)
        span.setAttribute('class', className)
        span.appendChild(text)
        elem.appendChild(span)
    })
}

document.querySelectorAll('.text-content').forEach(highlightCode)
// document.querySelectorAll('.text-content').forEach((elem, i) => {
//     setTimeout(() => highlightCode(elem), i * 600)
// })

{% endblock %}

codex_app/codex_app/templates/codex_app/image.html
{% load static %}
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>image</title>
    <style>
        body {
            font-family: monospace;
        }

        #viewport {
            position: absolute;
            top: 0;
            left: 1em;
            bottom: 0;
            overflow-y: auto;
            width: 72em;
        }

        .text-title {
            margin-left: 138px;
        }

        #tools {
            position: absolute;
            left: 74em;
            right: 0;
            top: 0;
            /* max-width: 32em; */
            bottom: 0;
            overflow-y: auto;
        }

        #tooltip-box {
            width: 0;
            height: 0;
            background-color: rgba(253, 253, 199, 0.253);
        }

        #tooltip-box.active {
            position: absolute;
            width: 100%;
            height: 100%;
            top: 0;
            left: 0;
        }

        .tooltip-inner {
            background-color: white;
            border: 1px solid lightcoral;
            padding: 1em;
        }

        .paragraph {
            margin: 1em 0;
            line-height: 170%;
            display: flex;
            flex-direction: row;
            align-items: baseline;
        }

        .paragraph .note {
            text-align: right;
            width: 138px;
            padding-right: 0.8em;
            flex-shrink: 0;
            font-size: 8pt;
            font-family: sans-serif;
            line-height: 120%;
        }

        .note-annotation {
            border-right: 1px solid lightgray;
            padding-right: 0.5em;
        }

        .paragraph .text {
            margin-right: 2em;
        }

        .rel {
            margin: 1em;
        }

        .depth-0 {
            padding-left: 0;
        }

        .depth-1 {
            padding-left: 2em;
        }

        .depth-2 {
            padding-left: 4em;
        }

        .cat-name,
        .term-name {
            font-weight: bold;
        }

        .annotated {
            background-color: #0084ff0a;
        }

        .highlight {
            background-color: #ff3c0038;
        }

        .note-annotation {
            cursor: pointer;
        }

        .n-1 {
            border-bottom: 1px solid grey;
        }

        .n-2 {
            border-bottom: 2px solid grey;
        }

        .n-3 {
            border-bottom: 3px solid grey;
        }

        .n-4 {
            border-bottom: 4px solid grey;
        }

        .cat-wrapper {
            display: inline-block;
        }

        .cat-select,
        .term-select {
            /* background-color: white;
                border-style: solid;
                border-radius: 2px;
                border-width: 1px;
                padding: 6px; */
            margin: 6px;
        }

        button:hover {
            background-color: blanchedalmond;
            /* border-color: black; */
        }

        button:disabled:hover {
            background-color: inherit;
            /* border-color: black; */
        }

        h3.cat-name,
        h3.term-name {
            font-size: 11pt;
            margin-bottom: 0;
        }

        a.cat-link,
        a.term-link {
            color: #4e4e4e;
        }

        .cat-select-short,
        .term-select-short {
            font-size: 6pt;
            margin-left: 2em;
            padding: 2px;
        }

        .image-wrapper {
            position: relative;
        }

        .image-wrapper img {
            position: absolute;
            top: 0;
            left: 0;
        }

        .image-wrapper svg {
            position: absolute;
            top: 0;
            left: 0;
        }

        .annot {
            width: 132px;
            display: flex;
            flex-direction: column;
            margin-right: 1em;
        }

        .annot-item {
            width: 120px;
            margin: 12px;
        }

        .extract {
            width: 100%;
        }

        #content-box {
            display: flex;
        }
    </style>
</head>

<body>
    <div id="viewport">
        <div id="title">
            <h1>{{title}}</h1>
        </div>
        <div id="content-box">
            <div id="annot"></div>
            <div id="image"></div>
        </div>
    </div>
    <div id="tools">
        <h2>Codex</h2>
        <div id="codex"></div>
    </div>
    <div id="tooltip-box"></div>
</body>
<script type="module">
    import { main } from "{% static 'codex_app/js/codex-image/index.js' %}";
    const image = [{{ image| safe }} ];
    const categories = {{ categories| safe }};
    const annotations = {{ annotations| safe }};
    const terms = {{ terms| safe }};
    main({
        "app/mode": 'image',
        image,
        categories,
        terms,
        "annotations/image": annotations,
        'app/csrf': "{{ csrf_token }}",
    });
</script>

</html>

codex_app/codex_app/templates/codex_app/index-image.html
{% extends "codex_app/base.html" %}
{% load thumbnail %}
{% block style %}
.image-list {
display: flex;
flex-wrap: wrap;
}
.image-list .image {
padding: 0.5em;
width: 300px;
border-bottom: 0.5px solid lightgrey;
}

.title a {
font-weight: bold;
color: grey;
}
{% endblock %}

{% block content %}


<h2>Images</h2>

<div class="image-list">
    {% for image in images %}
    <div class="image">
        <div class="title">
            <a href="{% url 'get_image' image.id %}">{{image}}</a>
        </div>
        <p>
            {{ image.imageannotation_set.count }} annotations
        </p>
        {% thumbnail image.file "100x100" crop="center" as im %}
        <img src="{{ im.url }}" width="{{ im.width }}" height="{{ im.height }}" />
        {% endthumbnail %}
    </div>
    {% endfor %}
</div>

{% endblock %}

codex_app/codex_app/templates/codex_app/term.html
{% extends "codex_app/base.html" %}
{% block title %}{{term.name}} — term{% endblock title %}
{% block style %}
#wrapper {
max-width: 44em;
margin-left: 3em;
}
.image-annotation-list {
display: flex;
flex-wrap: wrap;
}
.image-annotation-list .image-item {
width: 256px;
margin: 1em;
flex-shrink: 0;
}
.image-list .image-item img {
width: 100%;
}

.text-item{
margin: 6em 0;
}

.par-order {
float: left;
width: 2em;
font-size: 80%;
font-style: italic;
margin-left: -2em;
color: #5e5e5e;
}

.block {
/* color:rgb(83, 83, 83); */
color:rgb(126, 126, 126);
}
.block.code {
color:black;
/* font-weight: bold; */
}
.text-content:hover .block.code {
/* font-weight: bold; */
color:rgb(0, 24, 61);
}
.text-content:hover .block {
/* font-weight: bold; */
color:rgb(190, 190, 190);
}
{% endblock %}

{% block content %}
<div id="wrapper">
    <h1>{{term.name}}</h1>
    <div class="statement">{{term.statement}}</div>

    <h2>images</h2>
    <div class="image-list">
        {% for a in images%}
        <h3><a href="{% url 'get_image' a.image.id %}">{{a.image.name}}</a></h3>
        <div class="image-annotation-list">
            {% for ia in a.annotations %}
            <div class="image-item">
                <img class="annotation" src="{% url 'codex:get_img_annotation_image' ia.id %}" />
            </div>
            {% endfor %}
        </div>
        {% endfor %}
    </div>


    {% comment %} <h2>texts</h2> {% endcomment %}
    {% for item in texts%}
    <div class="text-item">
        <h3>
            <a href="{% url 'get_text' item.text.id %}">{{item.text.title}}</a>
        </h3>
        number of codes: {{item.count}}
        {% for p in item.paragraphs %}

        <p>
        <div class="par-order">{{p.par.order}}</div>
        <div class="text-content"
            data-intervals="[{% for a in p.annotations %}[{{a.start}},{{a.end}}]{%if not forloop.last %},{%endif%}{% endfor %}]"
            data-content="{{p.par.clean_content|escapejs}}">{{p.par.clean_content}}</div>
        </p>
        {% endfor %}
    </div>
    {% endfor %}


    <h2>source</h2>
    {% for rel in source %}
    <div class="rel">
        <a class="source" href="{% url 'get_term' rel.source.id %}">{{rel.source.name}}</a>
        ↪
        <a class="dest" href="{% url 'get_term' rel.destination.id %}">{{rel.destination.name}}</a>
        <a class="kind" href="{% url 'get_term' rel.kind.id %}">[{{rel.kind.name}}]</a>
    </div>
    {% endfor %}

    <h2>destination</h2>
    {% for rel in destination %}
    <div class="rel">
        <a class="source" href="{% url 'get_term' rel.source.id %}">{{rel.source.name}}</a>
        ↪
        <a class="dest" href="{% url 'get_term' rel.destination.id %}">{{rel.destination.name}}</a>
        <a class="kind" href="{% url 'get_term' rel.kind.id %}">[{{rel.kind.name}}]</a>
    </div>
    {% endfor %}
</div>
{% endblock %}

{% block script %}


function emptyElement(elem) {
while (elem.firstChild) {
removeElement(elem.firstChild);
}
return elem;
}

function removeElement(elem, keepChildren = false) {
if (!keepChildren) {
emptyElement(elem);
}
const parent = elem.parentNode;
if (parent) {
parent.removeChild(elem);
}
}


const sortInterval = (a,b) => a[0] - b[0]

const sortIntervals = (is) => is.sort(sortInterval)

const compileAnnotations = (content, rawIntervals) => {
const start = 0;
const end = content.length;
const intervals = [
...new Set(
sortIntervals(rawIntervals).reduce(
(acc, i) => acc.concat(i[0], i[1]),
[start, end]
)
),
].sort((a, b) => a - b);

const inInterval = (left, right) => rawIntervals.filter(
(a) => a[0] < right && a[1]> left
    ).length > 0;

    const blocks= [];
    for (let i = 1; i < intervals.length; i +=1) { blocks.push({ start: intervals[i - 1], end: intervals[i], content:
        content.slice(intervals[i - 1], intervals[i]), isCode: inInterval(intervals[i - 1], intervals[i]) }); } return
        blocks; } const highlightCode=(elem)=> {
        const intervals = JSON.parse(elem.getAttribute('data-intervals'))
        const content = JSON.parse('"' + elem.getAttribute('data-content') + '"')
        {% comment %} const content = elem.textContent {% endcomment %}
        const blocks = compileAnnotations(content, intervals)
        emptyElement(elem)
        blocks.forEach(block => {
        const className = `block ${block.isCode ? 'code' : ''}`
        const span = document.createElement('span')
        const text = document.createTextNode(block.content)
        span.setAttribute('class', className)
        span.appendChild(text)
        elem.appendChild(span)
        })
        }

        document.querySelectorAll('.text-content').forEach(highlightCode)
        // document.querySelectorAll('.text-content').forEach((elem, i) => {
        // setTimeout(() => highlightCode(elem), i * 600)
        // })

        {% endblock %}